#! /bin/bash

# wp_status.sh
# This file is part of the YATE Project http://YATE.null.ro
#
# Yet Another Telephony Engine - a fully featured software PBX and IVR
# Copyright (C) 2017 Null Team
#
# This software is distributed under multiple licenses;
# see the COPYING file in the main directory for licensing
# information for this specific distribution.
#
# This use of this software may be subject to additional restrictions.
# See the LEGAL file in the main directory for details.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

# Bourne shell script for retrieving a wanpipe interface status in Yate
# To use add in extmodule.conf
#
# [scripts]
# wp_status.sh
#
# Usage example in rmanager: status wanpipe w1g1


# install in Yate and run main loop
echo "%%>setlocal:trackparam:wp_status"
echo "%%>install:120:engine.status"
echo "%%>setlocal:restart:true"
while read -r REPLY; do
    case "$REPLY" in
	%%\>message:*)
	    # engine.status handling
	    id="${REPLY#*:*}"; id="${id%%:*}"
	    params=":${REPLY#*:*:*:*:*:}:"
	    # extract parameters, assume we don't need unescaping
	    mod="${params#*:module=}"; mod="${mod%%:*}"
	    res=""
	    case "X$mod" in
		Xwanpipe\ *)
		    mod="${mod#* }"
    res=`/usr/sbin/wanpipemon -c Ta -i "$mod" 2>/dev/null \
    | sed '/^ERROR:/d; s/| */\n/' \
    | sed 's/[[:space:]]*:[[:space:]]*/=/; s/[[:space:]]\+$//g; s/=OFF$/=false/; s/=ON$/=true/' \
    | awk 'BEGIN{s=";";p="rx_"} /E1 Tx/{p="tx_"} /E1 Perf|LIU/{p=""} {if(match($0,"^([A-Z][^=]*)=(.*)$",m)) {printf("%s%s%s=%s",s,p,gensub(" ","_","g",tolower(m[1])),m[2]);s=","}}'`
		    ;;
	    esac
	    if [ -n "$res" ]; then
		res=`echo "$res" | sed 's/%/%%/g; s/:/%z/g'`
		echo "%%<message:$id:true::module=wanpipe,type=misc,device=$mod$res%M%J"
	    else
		echo "%%<message:$id:false:"
	    fi
	    ;;
    esac
done

# vi: set ts=8 sw=4 sts=4 noet:
